(ns clojsa.saclient
  (:require [clojure.string :as string]
            [http.async.client :as http]))


(def url "https://forums.somethingawful.com/")

(defn thread-url
  ([id]
   (thread-url id 1))
  ([id page]
   (let [base-url (str url "showthread.php")
         query {:threadid id
                :pagenumber page}]
     {:href base-url :params query})))

(defn do-login []
  (let [login-url (str url "account.php")
        cs (clj-http.cookies/cookie-store)]
    (client/post login-url {:form-params {:action "login"
                                          :username "xf86enodev"
                                          :password "triebhaftigke1t"}
                            :cookie-store cs})
    (clj-http.cookies/get-cookies cs)))

(defn thread-response [session url]
  (with-open [client (http/create-client)]
    (let [{:keys [href params]} url
          resp (http/GET client href :query params)
          status (http/status resp)
          headers (http/headers resp)]
      (-> resp
          http/await
          http/string))))
